#ifndef _ILVSTINTERFACE_1AF23B68_H
#define _ILVSTINTERFACE_1AF23B68_H

#include <cstdint>



// vendor name
const int ILVI_VendorName	= 0x494C7669;	// "ILvi"

// commands
// -> sent by plugin
const int ILC_AddNotesToPR	= 0x100;		// Add notes to the piano roll | (in) ptr: pointer to TILNotesParams



#pragma pack(push)
#pragma pack(1)

typedef struct TILNoteParams
{
	int32_t Position;	// in PPQ
	int32_t Length;		// in PPQ
	// levels
	int32_t Pan;		// default=0
	float Vol;			// default=100/128
	int16_t Note;		// default=60
	int16_t Color;		// 0..15 (= MIDI channel)
	int32_t Pitch;		// default=0
	float FCut;			// default=0
	float FRes;			// default=0
};

typedef struct TILNotesParams
{
	int32_t Target;					// see NPT_PianoRoll
	int32_t Flags;					// see NPF_EmptyFirst
	int32_t PatNum;					// -1 for current
	int32_t ChanNum;				// -1 for plugin's channel, or selected channel if plugin is an effect
	int32_t Count;					// the # of notes in the structure
	TILNoteParams NoteParams[1];	// array of notes
};

#pragma pack(pop)



// TILNotesParams target values
const int32_t NPT_PianoRoll	= 1;	// add to piano roll

// TILNotesParams flags
const int32_t NPF_EmptyFirst	= 1 << 0;	// delete everything before adding the notes
const int32_t NPF_UseSelection	= 1 << 1;	// dump inside piano roll selection if any



#endif	// _ILVSTINTERFACE_1AF23B68_H