unit ILVSTInterface;

interface

const
     // vendor name
     ILVI_VendorName = $494C7669; // "ILvi"

     // commands
     // -> sent by plugin
     ILC_AddNotesToPR = $100;  // Add notes to the piano roll | (in) ptr: pointer to TILNotesParams



type
    TILNoteParams = packed record
      Position   : longint;    // in PPQ
      Length     : longint;    // in PPQ
      // levels
      Pan        : longint;    // default=0
      Vol        : single;     // default=100/128
      Note       : smallint;   // default=60
      Color      : smallint;   // 0..15 (= MIDI channel)
      Pitch      : integer;    // default=0
      FCut       : single;     // default=0
      FRes       : single;     // default=0
    end;

    PILNotesParams = ^TILNotesParams;
    TILNotesParams = packed record
      Target     : longint;   // see NPT_PianoRoll
      Flags      : longint;   // see NPF_EmptyFirst
      PatNum     : longint;   // -1 for current
      ChanNum    : longint;   // -1 for plugin's channel, or selected channel if plugin is an effect
      Count      : longint;   // the # of notes in the structure
      NoteParams : array[0..0] of TILNoteParams;  // array of notes
    end;



const
    // TILNotesParams target values
    NPT_PianoRoll = 1;   // add to piano roll

    // TILNotesParams flags
    NPF_EmptyFirst   = 1 shl 0;  // delete everything before adding the notes
    NPF_UseSelection = 1 shl 1;  // dump inside piano roll selection if any



implementation

end.
